VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUICommandList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsFoundationCollectionsIVector_1_Windows_UI_Popups_IUICommand As String = "Windows.Foundation.Collections.IVector`1<Windows.UI.Popups.IUICommand>"
Private Const IID___FIVector_1_Windows__CUI__CPopups__CIUICommand As String = "{105139a1-dcb8-5f65-97ef-cb1bf0b75f9d}"
Private Const IID___FIIterable_1_Windows__CUI__CPopups__CIUICommand As String = "{e63de42b-53c3-5e07-90d3-98172d545412}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IVector_IUICommand
    IVector_IUICommand_GetAt = 6
    IVector_IUICommand_GetSize = 7
'    IVector_IUICommand_GetView = 8
    IVector_IUICommand_IndexOf = 9
    IVector_IUICommand_SetAt = 10
    IVector_IUICommand_InsertAt = 11
    IVector_IUICommand_RemoveAt = 12
    IVector_IUICommand_Append = 13
    IVector_IUICommand_RemoveAtEnd = 14
    IVector_IUICommand_Clear = 15
'    IVector_IUICommand_GetMany = 16
'    IVector_IUICommand_ReplaceAll = 17

End Enum

' ----==== Variablen ====----
Private m_pIVector_IUICommand As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIVector_IUICommand)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pIVector_IUICommand
End Property

Public Property Let Ifc(ByVal pIVector_IUICommand As Long)
    Call ReleaseIfc(m_pIVector_IUICommand)
    m_pIVector_IUICommand = pIVector_IUICommand
End Property

' IVector_IUICommand
Public Property Get Size() As Long
    Dim Ret As Long
    If m_pIVector_IUICommand <> 0& Then
        Dim value As Long
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_GetSize, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Size = Ret
End Property

' ----==== Functions ====----
' IVector_IUICommand
Public Function GetAt(ByVal index As Long) As clsUICommand
    Dim Ret As New clsUICommand
    If m_pIVector_IUICommand <> 0& Then
        Dim pIUICommand As Long
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_GetAt, _
                  VarPtr(pIUICommand)) = S_OK Then
            Ret.Ifc = pIUICommand
        End If
    End If
    Set GetAt = Ret
End Function

'    IVector_IUICommand_GetView = 8

Public Function IndexOf(ByVal command As clsUICommand, _
                        ByRef index As Long) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& And _
       command.Ifc <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_IndexOf, _
                  command.Ifc, _
                  VarPtr(index)) = S_OK Then
            Ret = True
        End If
    End If
    IndexOf = Ret
End Function

Public Function SetAt(ByVal index As Long, _
                      ByVal command As clsUICommand) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& And _
       command.Ifc <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_SetAt, _
                  index, _
                  command.Ifc) = S_OK Then
            Ret = True
        End If
    End If
    SetAt = Ret
End Function

Public Function InsertAt(ByVal index As Long, _
                         ByVal command As clsUICommand) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& And _
       command.Ifc <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_InsertAt, _
                  index, _
                  command.Ifc) = S_OK Then
            Ret = True
        End If
    End If
    InsertAt = Ret
End Function

Public Function RemoveAt(ByVal index As Long) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_RemoveAt, _
                  index) = S_OK Then
            Ret = True
        End If
    End If
    RemoveAt = Ret
End Function

Public Function Append(ByVal command As clsUICommand) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& And _
       command.Ifc <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_Append, _
                  command.Ifc) = S_OK Then
            Ret = True
        End If
    End If
    Append = Ret
End Function

Public Function AppendSeparator(ByVal separator As clsUICommandSeparator) As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& And _
       separator.Ifc <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_Append, _
                  separator.Ifc) = S_OK Then
            Ret = True
        End If
    End If
    AppendSeparator = Ret
End Function

Public Function RemoveAtEnd() As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_RemoveAtEnd) = S_OK Then
            Ret = True
        End If
    End If
    RemoveAtEnd = Ret
End Function

Public Function Clear() As Boolean
    Dim Ret As Boolean
    If m_pIVector_IUICommand <> 0& Then
        If Invoke(m_pIVector_IUICommand, _
                  IVector_IUICommand_Clear) = S_OK Then
            Ret = True
        End If
    End If
    Clear = Ret
End Function

'    IVector_IUICommand_GetMany = 16
'    IVector_IUICommand_ReplaceAll = 17

' Extra Function
Public Function GetCommands() As clsUICommand
    Dim Ret() As New clsUICommand
    If m_pIVector_IUICommand <> 0& Then
        Dim count As Long
        Dim index As Long
        count = Me.Size
        If count > 0 Then
            For index = 0 To count - 1
                Set Ret(index) = Me.GetAt(index)
            Next
        End If
    End If
    GetCommands = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

