VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   2730
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   7185
   LinkTopic       =   "Form1"
   ScaleHeight     =   2730
   ScaleWidth      =   7185
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command4 
      Caption         =   "Show PopupMenu"
      Height          =   600
      Left            =   90
      TabIndex        =   3
      Top             =   2040
      Width           =   2600
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Show WindowsFlyout"
      Height          =   600
      Left            =   90
      TabIndex        =   2
      Top             =   1380
      Width           =   2600
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Show WindowDialog"
      Height          =   600
      Left            =   90
      TabIndex        =   1
      Top             =   720
      Width           =   2600
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Show MessageDialog"
      Height          =   600
      Left            =   90
      TabIndex        =   0
      Top             =   60
      Width           =   2600
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

Private WithEvents WindowDialog As clsWindowDialog
Attribute WindowDialog.VB_VarHelpID = -1
Private WithEvents WindowFlyOut As clsWindowFlyout
Attribute WindowFlyOut.VB_VarHelpID = -1
Private WithEvents CommandInvoked As clsUICommandInvokedHandler
Attribute CommandInvoked.VB_VarHelpID = -1

Private Sub Form_Load()
    Set CommandInvoked = New clsUICommandInvokedHandler
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set CommandInvoked = Nothing
End Sub


Private Sub Command1_Click()
    
    Dim MessageDialog As New clsMessageDialog
    If MessageDialog.CreateWithTitle("Content", "Title") Then
    
        Dim CommandList As clsUICommandList
        Set CommandList = MessageDialog.Commands

        ' max. 3 Buttons
        ' commandId can be an integer, a long, or a string.
        ' see clsUICommand -> IPropertyValue / IPropertyValueStatics
        Dim CommandButton As New clsUICommand
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&OK", CommandInvoked, 1))
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Maybe", CommandInvoked, 2))
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Cancel", CommandInvoked, 3))

        ' Optional
        MessageDialog.CancelCommandIndex = 2 ' Esc
        MessageDialog.DefaultCommandIndex = 2
        'MessageDialog.Options = MessageDialogOptions_AcceptUserInputAfterDelay
    
        Dim UICommand As clsUICommand
        Set UICommand = MessageDialog.ShowAsync(Me.hWnd)
        
        Debug.Print "Return from MessageDialog.ShowAsync"
        Debug.Print "UICommand.Label = " & UICommand.Label
        If VarType(UICommand.Id) <> vbEmpty Then Debug.Print "UICommand.Id = " & UICommand.Id
        Debug.Print
        
    End If
    
End Sub

Private Sub Command2_Click()
    Set WindowDialog = New clsWindowDialog
    If WindowDialog.CreateWithTitle("Title") Then
    
        Dim CommandList As clsUICommandList
        Set CommandList = WindowDialog.Commands

        ' max. 3 Buttons
        ' commandId can be an integer, a long, or a string.
        ' see clsUICommand -> IPropertyValue / IPropertyValueStatics
        Dim CommandButton As New clsUICommand
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&OK", CommandInvoked, 1))
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Maybe", CommandInvoked, 2))
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Cancel", CommandInvoked, 3))

        ' Optional
        WindowDialog.CancelCommandIndex = 2 ' Esc
        WindowDialog.DefaultCommandIndex = 2
        WindowDialog.BackButtonCommand = CommandInvoked
        'WindowDialog.IsInteractionDelayed = True

        Dim UICommand As clsUICommand
        Set UICommand = WindowDialog.ShowAsync(Me.hWnd)
        
        Debug.Print "Return from WindowDialog.ShowAsync"
        Debug.Print "UICommand.Label = " & UICommand.Label
        If VarType(UICommand.Id) <> vbEmpty Then Debug.Print "UICommand.Id = " & UICommand.Id
        Debug.Print
    End If
    Set WindowDialog = Nothing
End Sub

Private Sub Command3_Click()
    Set WindowFlyOut = New clsWindowFlyout
    If WindowFlyOut.CreateWithTitle(New_Windows_Foundation_Point(100, 100), "Title") Then
    
        Dim CommandList As clsUICommandList
        Set CommandList = WindowFlyOut.Commands

        ' max. 2 Buttons
        ' commandId can be an integer, a long, or a string.
        ' see clsUICommand -> IPropertyValue / IPropertyValueStatics
        Dim CommandButton As New clsUICommand
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&OK", CommandInvoked, 1))
        Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Cancel", CommandInvoked, 2))

        ' Optional
        WindowFlyOut.DefaultCommandIndex = 1
        WindowFlyOut.BackButtonCommand = CommandInvoked
        'WindowFlyOut.IsInteractionDelayed = True

        Dim UICommand As clsUICommand
        Set UICommand = WindowFlyOut.ShowAsync(Me.hWnd)
        
        Debug.Print "Return from WindowFlyOut.ShowAsync"
        Debug.Print "UICommand.Label = " & UICommand.Label
        If VarType(UICommand.Id) <> vbEmpty Then Debug.Print "UICommand.Id = " & UICommand.Id
        Debug.Print
    
    End If
    Set WindowFlyOut = Nothing
End Sub

Private Sub Command4_Click()
    Dim PopupMenu As New clsPopupMenu
    
    Dim CommandList As clsUICommandList
    Set CommandList = PopupMenu.Commands

    ' max. 6 Buttons, incl. CommandSeparator
    Dim CommandButton As New clsUICommand
    Dim CommandSeparator As New clsUICommandSeparator
    Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&OK", CommandInvoked, 1))
    Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Maybe", CommandInvoked, 2))
    Call CommandList.AppendSeparator(CommandSeparator)
    Call CommandList.Append(CommandButton.CreateWithHandlerAndId("&Cancel", CommandInvoked, 3))
    
    Dim UICommand As clsUICommand
    Set UICommand = PopupMenu.ShowAsync(Me.hWnd, New_Windows_Foundation_Point(250, 0))
    
    Debug.Print "Return from PopupMenu.ShowAsync"
    Debug.Print "UICommand.Label = " & UICommand.Label
    If VarType(UICommand.Id) <> vbEmpty Then Debug.Print "UICommand.Id = " & UICommand.Id
    Debug.Print
    
End Sub

Private Sub CommandInvoked_CommandInvoked(ByVal command As clsUICommand)
    Debug.Print "Return from CommandInvoked"
    Debug.Print "UICommand.Label = " & command.Label
    If VarType(command.Id) <> vbEmpty Then Debug.Print "UICommand.Id = " & command.Id
    Debug.Print
End Sub

Private Sub WindowDialog_CoreWindowPopupShowing(ByVal sender As Long, _
                                                ByVal args As clsCoreWindowPopupShowingEventArgs)
    Call args.SetDesiredSize(New_Windows_Foundation_Size(100, 100))
End Sub

Private Sub WindowFlyOut_CoreWindowPopupShowing(ByVal sender As Long, ByVal args As clsCoreWindowPopupShowingEventArgs)
    Call args.SetDesiredSize(New_Windows_Foundation_Size(100, 100))
End Sub
